function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var reactGridLayout = require('react-grid-layout');
var ReactApexChart = _interopDefault(require('react-apexcharts'));
var axios = _interopDefault(require('axios'));
var button = require('primereact/button');
var overlaypanel = require('primereact/overlaypanel');
var progressspinner = require('primereact/progressspinner');

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };
  return _extends.apply(this, arguments);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it) return (it = it.call(o)).next.bind(it);

  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it) o = it;
    var i = 0;
    return function () {
      if (i >= o.length) return {
        done: true
      };
      return {
        done: false,
        value: o[i++]
      };
    };
  }

  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var Tools = /*#__PURE__*/function () {
  function Tools() {}

  Tools.GetLogitudeURL = function GetLogitudeURL() {
    var logitude_url = location.href.replace('index.html', '');

    if (location.href.indexOf('localhost') > -1) {
      logitude_url = 'http://localhost:9996';
    } else {
      var urlArr = location.href.split("/index.html");
      var url = urlArr[0];
      url = url.replace(url.substring(url.lastIndexOf('/'), url.length), "");
      logitude_url = url;
    }

    return logitude_url;
  };

  Tools.Map = function Map(from, to) {
    if (!from) return;
    if (!to) to = {};
    var keys = Object.keys(from);

    for (var _i = 0, _keys = keys; _i < _keys.length; _i++) {
      var k = _keys[_i];

      if (from[k]) {
        to[k] = from[k];
      }
    }
  };

  return Tools;
}();

var ApiServices = /*#__PURE__*/function () {
  function ApiServices() {
    this._apiUrl = Tools.GetLogitudeURL();
  }

  var _proto = ApiServices.prototype;

  _proto.getByFilters = function getByFilters(api, filters) {
    var token = this.getTokenFromStorage();
    var apiURL = "" + this._apiUrl + api;
    apiURL = this.ConcatFiltersToURL(filters, apiURL);
    return axios.get(apiURL, {
      headers: {
        'Content-Type': 'application/json',
        'Token': token
      }
    });
  };

  _proto.get = function get(api) {
    var token = this.getTokenFromStorage();
    var apiURL = "" + this._apiUrl + api;
    return axios.get(apiURL, {
      headers: {
        'Content-Type': 'application/json',
        'Token': token
      }
    });
  };

  _proto.post = function post(api, date) {
    var token = this.getTokenFromStorage();
    var apiURL = "" + this._apiUrl + api;
    return axios.post(apiURL, date, {
      headers: {
        'Content-Type': 'application/json',
        'Token': token
      }
    });
  };

  _proto.getTokenFromStorage = function getTokenFromStorage() {
    return window.localStorage.getItem("token") || '';
  };

  _proto.ConcatFiltersToURL = function ConcatFiltersToURL(filters, urlparameters) {
    var mykeys = Object.keys(filters);
    var addtionalFiltersValues = null;

    for (var i in mykeys) {
      var propName = mykeys[i];
      var propValue = filters[propName];
      var ignoreFilter = propName.indexOf("Operator") > 0 && propValue == "Equals" || propName == "AdditionalFilters";

      if (urlparameters != "?") {
        urlparameters = urlparameters.concat('&');
      }

      if (!ignoreFilter) {
        propValue = propValue ? encodeURIComponent(propValue) : '';
        urlparameters = urlparameters.concat(propName.concat('=').concat(propValue));
      }

      if (propName == "AdditionalFilters" && propValue.length > 0) {
        addtionalFiltersValues = JSON.stringify(propValue);
      }
    }

    if (addtionalFiltersValues) {
      urlparameters = urlparameters.concat("&AdditionalFilters=").concat(addtionalFiltersValues);
    }

    return urlparameters;
  };

  return ApiServices;
}();

var DashboardAnalyticsService = /*#__PURE__*/function () {
  function DashboardAnalyticsService() {
    this.controller = 'DashboardAnalytics';
    this._ApiServices = new ApiServices();
  }

  var _proto = DashboardAnalyticsService.prototype;

  _proto.getData = function getData(widget) {
    return this._ApiServices.post("/api/" + this.controller + "/PostGetDataAnalytic", widget);
  };

  return DashboardAnalyticsService;
}();

var ApexChart = function ApexChart(props) {
  var _props$widget2;

  var _useState = React.useState(''),
      error = _useState[0],
      setEror = _useState[1];

  var widget = React.useRef();
  var widgetRef = React.useRef();
  var MeasuresIds = React.useRef([]);
  var GroupByIds = React.useRef([]);
  var GroupCount = React.useRef(0);

  var _useState2 = React.useState(false),
      isView = _useState2[0],
      setisView = _useState2[1];

  var _useState3 = React.useState(false),
      viewError = _useState3[0],
      setViewError = _useState3[1];

  var isDataLoaded = React.useRef(false);
  var hasDataError = React.useRef(false);
  var argsRef = React.useRef({
    series: [],
    options: {}
  });

  var _useState4 = React.useState({
    series: [],
    options: {}
  }),
      args = _useState4[0],
      serArgs = _useState4[1];

  var isLoadingDrow = React.useRef(true);
  React.useEffect(function () {
    var _props$dataBinding;

    setTimeout(function () {
      isLoadingDrow.current = false;
      updateView();
    }, 500);
    widget.current = props.widget;
    (_props$dataBinding = props.dataBinding) === null || _props$dataBinding === void 0 ? void 0 : _props$dataBinding.onEditWidget.subscribe(function (e) {
      var _widget$current;

      if (e.key == ((_widget$current = widget.current) === null || _widget$current === void 0 ? void 0 : _widget$current.key)) {
        Tools.Map(e, widget.current);
        RefreshData();
      }
    });
  }, []);
  React.useEffect(function () {
    widgetRef.current = props.widgetRef;
    RefreshData();
  }, []);
  React.useEffect(function () {
    widgetRef.current = props.widgetRef;
  }, [props.widgetRef]);

  var RefreshData = function RefreshData() {
    var dashboardAnalyticsService = new DashboardAnalyticsService();

    var postWidget = _extends({}, widget.current);

    postWidget.onChange = undefined;
    isDataLoaded.current = false;
    updateView();
    dashboardAnalyticsService.getData(postWidget).then(function (result) {
      fillIds(result.data);
      var data = getChartOptions(result.data);
      serArgs(data);
      argsRef.current = data;
      isDataLoaded.current = true;
      hasDataError.current = false;
      updateView();
    }, function (error) {
      var _error$response, _error$response$data, _error$response2, _error$response2$data;

      console.log('error', error);
      if (error !== null && error !== void 0 && (_error$response = error.response) !== null && _error$response !== void 0 && (_error$response$data = _error$response.data) !== null && _error$response$data !== void 0 && _error$response$data.ErrorMessage) setEror(error === null || error === void 0 ? void 0 : (_error$response2 = error.response) === null || _error$response2 === void 0 ? void 0 : (_error$response2$data = _error$response2.data) === null || _error$response2$data === void 0 ? void 0 : _error$response2$data.ErrorMessage);else setEror(error.message);
      isDataLoaded.current = true;
      hasDataError.current = true;
      updateView();
    });
  };

  var fillIds = function fillIds(datas) {
    var measuresIds = [];
    var groupByIds = [];

    for (var _iterator = _createForOfIteratorHelperLoose(datas), _step; !(_step = _iterator()).done;) {
      var seriesMeasure = _step.value;
      measuresIds.push(seriesMeasure.MeasureFieldId);
    }

    for (var _iterator2 = _createForOfIteratorHelperLoose(datas), _step2; !(_step2 = _iterator2()).done;) {
      var _seriesMeasure = _step2.value;

      for (var _iterator3 = _createForOfIteratorHelperLoose(_seriesMeasure.SeriesMeasureVulues), _step3; !(_step3 = _iterator3()).done;) {
        var vulue = _step3.value;
        groupByIds.push(vulue.GroupById);
      }

      break;
    }

    MeasuresIds.current = measuresIds;
    GroupByIds.current = groupByIds;
  };

  var updateView = function updateView() {
    if (isDataLoaded.current && !isLoadingDrow.current && !hasDataError.current) {
      setisView(true);
      setViewError(false);
    }

    if (!isDataLoaded.current && !isLoadingDrow.current) {
      setisView(false);
    }

    if (isDataLoaded.current && !isLoadingDrow.current && hasDataError.current) {
      setisView(false);
      setViewError(true);
    }
  };

  var lineOptoins = function lineOptoins(values) {
    var series = [];
    var categories = [];

    if (values && values[0]) {
      series = values.map(function (e) {
        return {
          data: e.SeriesMeasureVulues.map(function (z) {
            return z.Value;
          })
        };
      });
      categories = values[0].SeriesMeasureVulues.map(function (e) {
        return e.Label;
      });
    }

    return {
      series: series,
      options: {
        chart: {
          height: 350,
          type: 'line',
          zoom: {
            enabled: false
          },
          events: {
            click: dataPointSelection
          },
          toolbar: {
            tools: {
              download: false
            }
          }
        },
        dataLabels: {
          enabled: false
        },
        stroke: {
          curve: 'straight'
        },
        title: {
          text: '',
          align: 'left'
        },
        grid: {
          row: {
            colors: ['#f3f3f3', 'transparent'],
            opacity: 0.5
          }
        },
        xaxis: {
          categories: categories,
          labels: {
            formatter: formatVerticalLabel
          }
        },
        yaxis: {
          labels: {
            minWidth: 60,
            padding: 7
          }
        },
        noData: {
          text: 'No Data Found'
        }
      }
    };
  };

  var barOptoins = function barOptoins(values) {
    var series = [{
      data: []
    }];
    var categories = [];

    if (values && values[0]) {
      series = values.map(function (e) {
        return {
          data: e.SeriesMeasureVulues.map(function (z) {
            return z.Value;
          })
        };
      });
      categories = values[0].SeriesMeasureVulues.map(function (e) {
        return e.Label;
      });
    }

    return {
      series: series,
      options: {
        chart: {
          type: 'bar',
          height: 430,
          events: {
            dataPointSelection: dataPointSelection
          },
          toolbar: {
            tools: {
              download: false
            }
          }
        },
        plotOptions: {
          bar: {
            horizontal: true,
            borderRadius: 4,
            dataLabels: {
              position: 'top'
            }
          }
        },
        dataLabels: {
          enabled: false,
          offsetX: -6,
          style: {
            fontSize: '12px',
            colors: ['#fff']
          }
        },
        stroke: {
          show: true,
          width: 1,
          colors: ['#fff']
        },
        tooltip: {
          shared: true,
          intersect: false
        },
        xaxis: {
          categories: categories,
          labels: {
            formatter: formatVerticalLabel
          }
        },
        yaxis: {
          labels: {
            minWidth: 60,
            padding: 7
          }
        },
        noData: {
          text: 'No Data Found'
        }
      }
    };
  };

  var pieOptoins = function pieOptoins(values) {
    var series = [];
    var labels = [];

    if (values && values[0]) {
      series = values[0].SeriesMeasureVulues.map(function (e) {
        return e.Value;
      });
      labels = values[0].SeriesMeasureVulues.map(function (e) {
        return e.Label;
      });
    }

    var colors = CreateColors(labels.length);
    return {
      series: series,
      options: {
        chart: {
          type: 'pie',
          events: {
            dataPointSelection: dataPointSelection
          },
          toolbar: {
            tools: {
              download: false
            }
          },
          animations: {
            enabled: true,
            easing: 'easeinout',
            speed: 800,
            animateGradually: {
              enabled: true,
              delay: 150
            },
            dynamicAnimation: {
              enabled: true,
              speed: 350
            }
          }
        },
        labels: labels,
        colors: colors,
        tooltip: {
          fillSeriesColor: false
        },
        noData: {
          text: 'No Data Found'
        },
        legend: {
          formatter: formatLabel
        },
        stroke: {
          width: 0
        }
      }
    };
  };

  var formatLabel = function formatLabel(legendName, opts) {
    var _widgetRef$current, _widgetRef$current$La, _widgetRef$current2, _widgetRef$current2$L;

    var LayoutWidth = (_widgetRef$current = widgetRef.current) === null || _widgetRef$current === void 0 ? void 0 : (_widgetRef$current$La = _widgetRef$current.Layout) === null || _widgetRef$current$La === void 0 ? void 0 : _widgetRef$current$La.w;
    var Layoutheight = (_widgetRef$current2 = widgetRef.current) === null || _widgetRef$current2 === void 0 ? void 0 : (_widgetRef$current2$L = _widgetRef$current2.Layout) === null || _widgetRef$current2$L === void 0 ? void 0 : _widgetRef$current2$L.h;
    console.log('W,H (', LayoutWidth, Layoutheight, ')');
    var width = 120 * LayoutWidth / 3;
    var text = "<div style=\"white-space: nowrap; text-overflow: clip; overflow: hidden;width:" + width + "px;display: inline-block; \">" + legendName + "</div>";
    return text;
  };

  var formatVerticalLabel = function formatVerticalLabel(val, opts) {
    var text = TpCapitalize(val);
    if (val && val.length > 20) text = text.substring(0, 20);
    return text;
  };

  var TpCapitalize = function TpCapitalize(val) {
    var _val, _val2;

    if (!((_val = val) !== null && _val !== void 0 && _val.split)) return val;
    val = val.toLocaleLowerCase();
    var words = (_val2 = val) === null || _val2 === void 0 ? void 0 : _val2.split(" ");

    for (var i = 0; i < words.length; i++) {
      words[i] = words[i][0].toUpperCase() + words[i].substr(1);
    }

    return words.join(" ");
  };

  var CreateColors = function CreateColors(count) {
    GroupCount.current = count;
    var colors = [];
    CreateDifferentColors(colors, 0, 100, 50);
    if (GroupCount.current <= 0) return colors;
    CreateDifferentColors(colors, 15, 100, 50);
    if (GroupCount.current <= 0) return colors;
    CreateDifferentColors(colors, 0, 50, 50);
    if (GroupCount.current <= 0) return colors;
    CreateDifferentColors(colors, 15, 50, 50);
    if (GroupCount.current <= 0) return colors;
    CreateDifferentColors(colors, 0, 50, 30);
    if (GroupCount.current <= 0) return colors;
    CreateDifferentColors(colors, 15, 50, 30);
    if (GroupCount.current <= 0) return colors;
    return undefined;
  };

  var CreateDifferentColors = function CreateDifferentColors(colors, startAngle, s, v) {
    for (var index = 0; GroupCount.current > 0 && index < 12; index++) {
      var color = "hsl(" + (startAngle + index * 30) + "deg " + s + "% " + v + "%)";
      colors.push(color);
      GroupCount.current--;
    }
  };

  var donutOptoins = function donutOptoins(values) {
    var series = [];
    var labels = [];

    if (values && values[0]) {
      series = values[0].SeriesMeasureVulues.map(function (e) {
        return e.Value;
      });
      labels = values[0].SeriesMeasureVulues.map(function (e) {
        return e.Label;
      });
    }

    var colors = CreateColors(labels.length);
    var result = {
      series: series,
      options: {
        chart: {
          width: 380,
          type: 'donut',
          events: {
            dataPointSelection: dataPointSelection
          },
          toolbar: {
            tools: {
              download: false
            }
          }
        },
        dataLabels: {
          enabled: false
        },
        responsive: [{
          breakpoint: 480,
          options: {
            chart: {
              width: 200
            },
            legend: {
              show: false
            }
          }
        }],
        legend: {
          position: 'right',
          offsetY: 0,
          height: 230,
          formatter: formatLabel
        },
        labels: labels,
        colors: colors,
        tooltip: {
          fillSeriesColor: false
        },
        noData: {
          text: 'No Data Found'
        },
        stroke: {
          width: 0
        }
      }
    };
    return result;
  };

  var handelNullLabels = function handelNullLabels(values) {
    values.forEach(function (element) {
      element.SeriesMeasureVulues.forEach(function (value) {
        if (!value.Label || value.Label == '') value.Label = 'Not defined';
      });
    });
  };

  var dataPointSelection = function dataPointSelection(e, chart, options) {
    console.log(options.dataPointIndex, options.seriesIndex);
    if (options.seriesIndex < 0 || options.seriesIndex > MeasuresIds.current.length - 1) options.seriesIndex = 0;

    if (options.dataPointIndex >= 0) {
      console.log(options.dataPointIndex, options.seriesIndex);
      props.onSelectDataPoint({
        GroupById: GroupByIds.current[options.dataPointIndex],
        MeasureFieldId: MeasuresIds.current[options.seriesIndex],
        Widget: props.widget
      });
    }
  };

  var getChartOptions = function getChartOptions(values) {
    var _props$widget;

    handelNullLabels(values);

    switch ((_props$widget = props.widget) === null || _props$widget === void 0 ? void 0 : _props$widget.TypeCode) {
      case 'bar':
        return barOptoins(values);

      case 'line':
        return lineOptoins(values);

      case 'pie':
        return pieOptoins(values);

      case 'donut':
        return donutOptoins(values);
    }

    return barOptoins(values);
  };

  return !isView && !viewError ? React__default.createElement("div", {
    className: 'dl-full-hight dl-flex-content-center spinner-custome'
  }, React__default.createElement(progressspinner.ProgressSpinner, {
    style: {
      width: '100px',
      height: '100px'
    },
    strokeWidth: "4",
    animationDuration: "2s"
  })) : isView ? React__default.createElement(ReactApexChart, {
    options: args === null || args === void 0 ? void 0 : args.options,
    series: args === null || args === void 0 ? void 0 : args.series,
    type: (_props$widget2 = props.widget) === null || _props$widget2 === void 0 ? void 0 : _props$widget2.TypeCode,
    height: "100%",
    width: "100%"
  }) : React__default.createElement("div", {
    className: "dl-flex-content-center dl-full-hight "
  }, React__default.createElement("div", {
    className: "dl-tooltip"
  }, React__default.createElement("img", {
    width: 100,
    src: "https://www.seekpng.com/png/full/334-3345964_error-icon-png.png"
  }), React__default.createElement("span", {
    className: "dl-tooltiptext"
  }, error)));
};

var WidgetCard = function WidgetCard(props, state) {
  var _props$widget;

  var moreBtnToggle = React.useRef(null);

  var editWidget = function editWidget() {
    var _moreBtnToggle$curren;

    (_moreBtnToggle$curren = moreBtnToggle.current) === null || _moreBtnToggle$curren === void 0 ? void 0 : _moreBtnToggle$curren.hide();
    props.editBtnClicked(props.widget);
  };

  return React__default.createElement("div", {
    className: "panel",
    key: props.el.i
  }, React__default.createElement("header", {
    style: {
      paddingLeft: "5px;"
    }
  }, React__default.createElement("h1", null, ((_props$widget = props.widget) === null || _props$widget === void 0 ? void 0 : _props$widget.Title) || "not set"), props.isInEditMode ? React__default.createElement(button.Button, {
    icon: "pi pi-ellipsis-v",
    className: "p-button-lg p-button-rounded p-button-text",
    onClick: function onClick(e) {
      var _moreBtnToggle$curren2;

      return (_moreBtnToggle$curren2 = moreBtnToggle.current) === null || _moreBtnToggle$curren2 === void 0 ? void 0 : _moreBtnToggle$curren2.toggle(e);
    }
  }) : null, React__default.createElement(overlaypanel.OverlayPanel, {
    ref: moreBtnToggle,
    className: "buttons-overlay"
  }, React__default.createElement("div", {
    className: "buttons-list"
  }, React__default.createElement("div", {
    onClick: editWidget
  }, " Edit "), React__default.createElement("div", {
    onClick: function onClick() {
      var _props$widget2;

      return props.deleteBtnClicked((_props$widget2 = props.widget) === null || _props$widget2 === void 0 ? void 0 : _props$widget2.key);
    }
  }, "Remove")))), React__default.createElement("div", {
    className: "dl-dashboard-widget"
  }, React__default.createElement(ApexChart, {
    dataBinding: props.dataBinding,
    widget: props.widget,
    widgetRef: props.widgetRef,
    onSelectDataPoint: props.onSelectDataPoint
  })));
};

function deepClone(obj) {
  return JSON.parse(JSON.stringify(obj));
}

var ResponsiveReactGridLayout = reactGridLayout.WidthProvider(reactGridLayout.Responsive);

var DashboardDesigner = function DashboardDesigner(props) {
  var array12 = Array.from({
    length: 12
  }).fill(null);
  var minimumPlaceholderRowsCount = 12;

  var _useState = React.useState({
    lg: []
  }),
      layouts = _useState[0],
      setLayouts = _useState[1];

  var _useState2 = React.useState(Array.from({
    length: minimumPlaceholderRowsCount
  }).fill(null)),
      placeholderRowsArray = _useState2[0],
      setplaceholderRowsArray = _useState2[1];

  var _useState3 = React.useState(undefined),
      dateFilter = _useState3[0];

  var _useState4 = React.useState(false),
      isInEditMode = _useState4[0],
      setisInEditMode = _useState4[1];

  var widgetsDictionaryRef = React.useRef({});

  var _useState5 = React.useState({
    lg: []
  }),
      widgets = _useState5[0],
      setWidgets = _useState5[1];

  var gridLayoutComponent = React.useRef(null);
  React.useEffect(function () {
    FillLayout(props.Widgetlayouts);
  }, [props.Widgetlayouts]);

  var FillLayout = function FillLayout(dashboardLayouts) {
    var clone = deepClone(dashboardLayouts);
    var layout = createLayout(clone);
    FillWidgetDictionary(clone);
    setWidgets(clone);
    setLayouts(layout);
    UpdatePlaceholderDimensions(layout);
  };

  var FillWidgetDictionary = function FillWidgetDictionary(clone) {
    for (var _iterator = _createForOfIteratorHelperLoose(clone.lg), _step; !(_step = _iterator()).done;) {
      var item = _step.value;
      widgetsDictionaryRef.current[item.key] = item;
    }
  };

  var createLayout = function createLayout(dashboardLayouts) {
    var layout = {
      lg: []
    };
    dashboardLayouts.lg.map(function (w) {
      return w.Layout;
    }).forEach(function (e) {
      layout.lg.push(e);
    });
    return layout;
  };

  React.useEffect(function () {
    setisInEditMode(props.editMode);
  }, [props.editMode]);

  function _onLayoutChange(layout, changedLayouts) {
    UpdateWidget(changedLayouts);
    setLayouts(changedLayouts);
    UpdatePlaceholderDimensions(changedLayouts);
    props.onLayoutChange(changedLayouts);
  }

  function UpdateWidget(changedLayouts) {
    for (var _iterator2 = _createForOfIteratorHelperLoose(changedLayouts.lg), _step2; !(_step2 = _iterator2()).done;) {
      var item = _step2.value;

      if (widgetsDictionaryRef.current[item.i]) {
        widgetsDictionaryRef.current[item.i].Layout = item;
      }
    }
  }

  function deletePanel(id) {
    var newLayouts = {
      lg: layouts.lg.filter(function (e) {
        return e.i != id;
      })
    };
    setLayouts(newLayouts);
    var newWidgets = {
      lg: widgets.lg.filter(function (e) {
        return e.key != id;
      })
    };
    FillWidgetDictionary(newWidgets);
    setWidgets(newWidgets);
    props.onLayoutChange(newLayouts);
  }

  function editWidget(widget) {
    widget.ChangeSetOp = 'Update';
    props.openEditWidget(widget);
  }

  function UpdatePlaceholderDimensions(layouts) {
    if (!layouts) return;
    var max = minimumPlaceholderRowsCount;

    for (var _iterator3 = _createForOfIteratorHelperLoose(layouts['lg']), _step3; !(_step3 = _iterator3()).done;) {
      var layout = _step3.value;
      if (layout.y + layout.h > max) max = layout.y + layout.h;
    }

    var newPlaceholderRows = max + 2;
    newPlaceholderRows = newPlaceholderRows < minimumPlaceholderRowsCount ? minimumPlaceholderRowsCount : newPlaceholderRows;
    setplaceholderRowsArray(Array.from({
      length: newPlaceholderRows
    }).fill(null));
  }

  return React__default.createElement("div", {
    className: "dl-full-hight"
  }, React__default.createElement("div", {
    className: "dl-box"
  }, React__default.createElement("div", {
    className: "dl-row dl-content"
  }, React__default.createElement("div", {
    className: "dl-grid-container"
  }, React__default.createElement("div", {
    className: "dl-grid dl-grid--bordered"
  }, isInEditMode ? placeholderRowsArray.map(function (e, i) {
    return array12.map(function (e, i) {
      return React__default.createElement("div", {
        key: i,
        style: {
          height: layoutGridProps.rowHeight
        }
      });
    });
  }) : null), React__default.createElement(ResponsiveReactGridLayout, Object.assign({
    ref: gridLayoutComponent
  }, layoutGridProps, {
    layouts: layouts,
    compactType: "vertical",
    isDraggable: isInEditMode,
    isResizable: isInEditMode,
    onWidthChange: function onWidthChange() {},
    onLayoutChange: function onLayoutChange(layout, layouts) {
      return _onLayoutChange(layout, layouts);
    }
  }), widgets.lg.map(function (widget) {
    var _widget$Layout, _widget$Layout2;

    return React__default.createElement("div", {
      key: (_widget$Layout = widget.Layout) === null || _widget$Layout === void 0 ? void 0 : _widget$Layout.i
    }, React__default.createElement(WidgetCard, {
      isInEditMode: isInEditMode,
      key: (_widget$Layout2 = widget.Layout) === null || _widget$Layout2 === void 0 ? void 0 : _widget$Layout2.i,
      widget: widget,
      widgetRef: widgetsDictionaryRef.current[widget.key],
      el: widget,
      dataBinding: props.dataBinding,
      dateFilter: dateFilter,
      editBtnClicked: editWidget,
      deleteBtnClicked: deletePanel,
      onSelectDataPoint: props.onSelectDataPoint
    }));
  }))))));
};

var layoutGridProps = {
  rowHeight: 50,
  className: "layout",
  cols: {
    lg: 12,
    md: 6,
    sm: 2,
    xs: 1,
    xxs: 1
  },
  useCSSTransforms: true
};

var Dashboard = function Dashboard(props) {
  var _props$token;

  var _useState = React.useState({
    lg: []
  });
  var Widgetlayouts = React.useRef({
    lg: []
  });
  var FirstSetLayout = React.useRef(false);

  var _useState2 = React.useState({
    lg: []
  }),
      widgetlayoutsState = _useState2[0],
      setWidgetlayoutsState = _useState2[1];

  var _useState3 = React.useState(false),
      isInEditMode = _useState3[0],
      setIsInEditMode = _useState3[1];

  React.useEffect(function () {
    props.dataBinding.onGetLayouts.subscribe(function (layouts) {
      FirstSetLayout.current = true;
      Widgetlayouts.current = layouts;
      setWidgetlayoutsState(deepClone(Widgetlayouts.current));
    });
    props.dataBinding.isOnEditLayout.subscribe(function (e) {
      setIsInEditMode(e);
    });
    props.dataBinding.onAddWidget.subscribe(function (w) {
      Widgetlayouts.current.lg.push(w);
      setWidgetlayoutsState(deepClone(Widgetlayouts.current));
    });
  }, []);
  if ((props === null || props === void 0 ? void 0 : (_props$token = props.token) === null || _props$token === void 0 ? void 0 : _props$token.length) > 0) localStorage.setItem("token", props === null || props === void 0 ? void 0 : props.token);

  var updateWidgets = function updateWidgets(layouts) {
    if (FirstSetLayout.current) {
      FirstSetLayout.current = false;
      return;
    }

    var layoutsDic = {};
    Object.keys(layouts).forEach(function (sizeType) {
      if (layouts[sizeType].length > 0) {
        layouts[sizeType].map(function (layout) {
          layoutsDic[layout.i] = layout;
        });
        return;
      }
    });
    var newWidgetlayouts = [];
    Widgetlayouts.current.lg.forEach(function (widget) {
      if (layoutsDic[widget.key]) {
        widget.StartPotistion = layoutsDic[widget.key].x + "," + layoutsDic[widget.key].y;
        widget.EndPosition = layoutsDic[widget.key].w + "," + layoutsDic[widget.key].h;
        widget.Layout = layoutsDic[widget.key];
        newWidgetlayouts.push(widget);
      }
    });
    Widgetlayouts.current = {
      lg: newWidgetlayouts
    };
    props.onChangeLayouts(Widgetlayouts.current);
  };

  return React.createElement("div", {
    className: 'dl-full-hight'
  }, React.createElement("div", {
    className: 'dl-dashboard-body'
  }, React.createElement(DashboardDesigner, {
    onSelectDataPoint: props.onSelectDataPoint,
    Widgetlayouts: widgetlayoutsState,
    dataBinding: props.dataBinding,
    editMode: isInEditMode,
    onLayoutChange: updateWidgets,
    openEditWidget: function openEditWidget(widget) {
      return props.openEditWidget(widget);
    }
  })));
};

module.exports = Dashboard;
//# sourceMappingURL=index.js.map
